<!DOCTYPE html>
<html lang="en" xmlns="http://www.w3.org/1999/xhtml" xmlns:th="https://www.thymeleaf.org">
    <head>
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

        <link rel="stylesheet" type="text/css" media="all" th:href="@{/css/bootstrap.min.css}">

        <title>Home</title>
    </head>
    <body class="p-3 mb-2 bg-light text-black">
        <div class="container">
            <div id="messageDiv">
                <div th:if="${fileUploaded}" class="alert alert-success alert-dismissible text-center fade show" role="alert">
                    <span>File uploaded</span>
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div th:if="${fileDeleted}" class="alert alert-warning alert-dismissible text-center fade show" role="alert">
                    <span>File deleted</span>
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div th:if="${fileExists}" class="alert alert-danger alert-dismissible text-center fade show" role="alert">
                    <span>File already exists</span>
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div th:if="${fileSizeExceedsLimit}" class="alert alert-danger alert-dismissible text-center fade show" role="alert">
                    <span>File size too large</span>
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div th:if="${noteSaved}" class="alert alert-success alert-dismissible text-center fade show" role="alert">
                    <span>Note saved</span>
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div th:if="${noteDeleted}" class="alert alert-warning alert-dismissible text-center fade show" role="alert">
                    <span>Note deleted</span>
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div th:if="${credentialSaved}" class="alert alert-success alert-dismissible text-center fade show" role="alert">
                    <span>Credential saved</span>
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div th:if="${credentialDeleted}" class="alert alert-warning alert-dismissible text-center fade show" role="alert">
                    <span>Credential deleted</span>
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
            </div>
            <div id="logoutDiv">
                <form th:action="@{/logout}" action="#" method="POST">
                    <button type="submit" class="btn btn-secondary float-right" id="logout-button">Logout</button>
                </form>
            </div>
            <div id="contentDiv" style="clear: right;">
                <nav style="clear: right;">
                    <div class="nav nav-tabs" id="nav-tab" role="tablist">
                        <a class="nav-item nav-link" th:classappend="${#strings.equals(activeTab, 'files') ? 'active' : ''}" id="nav-files-tab" data-toggle="tab" href="#nav-files" role="tab" aria-controls="nav-files" aria-selected="true">Files</a>
                        <a class="nav-item nav-link" th:classappend="${#strings.equals(activeTab, 'notes') ? 'active' : ''}" id="nav-notes-tab" data-toggle="tab" href="#nav-notes" role="tab" aria-controls="nav-notes" aria-selected="false">Notes</a>
                        <a class="nav-item nav-link" th:classappend="${#strings.equals(activeTab, 'credentials') ? 'active' : ''}" id="nav-credentials-tab" data-toggle="tab" href="#nav-credentials" role="tab" aria-controls="nav-credentials" aria-selected="false">Credentials</a>
                    </div>
                </nav>
                <div class="tab-content" id="nav-tabContent">
                    <div class="tab-pane fade" th:classappend="${#strings.equals(activeTab, 'files') ? 'show active' : ''}" id="nav-files" role="tabpanel" aria-labelledby="nav-files-tab">
                        <form th:action="@{/file-upload}" action="#" enctype="multipart/form-data" method="POST">
                            <div class="container">
                                <div class="row" style="margin: 1em;">
                                    <div class="col-sm-2">
                                        <label for="fileUpload">Upload a New File:</label>
                                    </div>
                                    <div class="col-sm-6">
                                        <input type="file" class="form-control-file" id="fileUpload" name="fileUpload">
                                    </div>
                                    <div class="col-sm-4">
                                        <button type="submit" class="btn btn-dark">Upload</button>
                                    </div>
                                </div>
                            </div>
                        </form>
                        <div class="table-responsive">
                            <table class="table table-striped" id="fileTable">
                                <thead>
                                    <tr>
                                        <th style="width: 20%" scope="col"></th>
                                        <th style="width: 80%" scope="col">File Name</th>
                                    </tr>
                                </thead>
                                <tbody>
                                <tr th:each="fileName : ${fileNames}">
                                    <td>
                                        <a target="_blank" class="btn btn-success" th:href="@{/file-view(fileName=${fileName})}">View</a>
                                        <a class="btn btn-danger" th:href="@{/file-delete(fileName=${fileName})}">Delete</a>
                                    </td>
                                    <td th:text="${fileName}">ExampleFile.txt</td>
                                </tr>
                                </tbody>
                            </table>
                        </div>
                    </div>
                    <div class="tab-pane fade" th:classappend="${#strings.equals(activeTab, 'notes') ? 'show active' : ''}" id="nav-notes" role="tabpanel" aria-labelledby="nav-notes-tab">
                        <button style="margin: 0.25em;" type="button" class="btn btn-info float-right" onclick="showNoteModal()" id="add-note-button">
                            + Add a New Note
                        </button>

                        <div class="table-responsive">
                            <table class="table table-striped" id="noteTable">
                                <thead>
                                    <tr>
                                        <th style="width: 20%" scope="col"></th>
                                        <th style="width: 20%" scope="col">Title</th>
                                        <th style="width: 60%" scope="col">Description</th>
                                    </tr>
                                </thead>
                                <tbody>
                                    <tr th:each="note : ${notes}">
                                        <td>
                                            <button th:onclick="showNoteModal([[${note}]])" type="button" class="btn btn-success" id="edit-note-button">Edit</button>
                                            <a class="btn btn-danger" th:href="@{/note-delete(noteId=${note.getNoteId()})}" id="delete-note-button">Delete</a>
                                        </td>
                                        <td th:text="${note.getNoteTitle()}">Example Note Title</td>
                                        <td th:text="${note.getNoteDescription()}">Example Note Description </td>
                                    </tr>
                                </tbody>
                            </table>
                        </div>

                        <div class="modal fade" id="noteModal" tabindex="-1" role="dialog" aria-labelledby="noteModalLabel" aria-hidden="true">
                            <div class="modal-dialog" role="document">
                                <div class="modal-content">
                                    <div class="modal-header">
                                        <h5 class="modal-title" id="noteModalLabel">Note</h5>
                                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                            <span aria-hidden="true">&times;</span>
                                        </button>
                                    </div>
                                    <div class="modal-body">
                                        <form th:object="${note}" th:action="@{/note-save}" action="#" method="POST">
                                            <input th:field="*{noteId}" type="hidden" name="noteId" id="note-id">
                                            <div class="form-group">
                                                <label for="note-title" class="col-form-label">Title</label>
                                                <input th:field="*{noteTitle}" type="text" name="noteTitle" class="form-control" id="note-title" maxlength="20" required>
                                            </div>
                                            <div class="form-group">
                                                <label for="note-description" class="col-form-label">Description</label>
                                                <textarea th:field="*{noteDescription}" class="form-control" name="noteDescription" id="note-description" rows="5" maxlength="1000" required></textarea>
                                            </div>
                                            <button id="noteSubmit" type="submit" class="d-none"></button>
                                        </form>
                                    </div>
                                    <div class="modal-footer">
                                        <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                                        <button type="button" class="btn btn-primary" onclick="$('#noteSubmit').click();" id="save-note-button">Save changes</button>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="tab-pane fade" th:classappend="${#strings.equals(activeTab, 'credentials') ? 'show active' : ''}" id="nav-credentials" role="tabpanel" aria-labelledby="nav-credentials-tab">
                        <button style="margin: 0.25em;" type="button" class="btn btn-info float-right" onclick="showCredentialModal()" id="add-credential-button">
                            + Add a New Credential
                        </button>

                        <div class="table-responsive">
                            <table class="table table-striped" th:object="${credentials}" id="credentialTable">
                                <thead>
                                    <tr>
                                        <th style="width: 20%" scope="col"></th>
                                        <th style="width: 35%" scope="col">URL</th>
                                        <th style="width: 20%" scope="col">Username</th>
                                        <th style="width: 25%" scope="col">Password</th>
                                    </tr>
                                </thead>
                                <tbody>
                                    <tr th:each="credential : ${credentials}">
                                        <td>
                                            <button th:onclick="showCredentialModal([[${credential}]], [[${credentialService.getDecryptedPassword(credential)}]])" type="button" class="btn btn-success" id="edit-credential-button">Edit</button>
                                            <a class="btn btn-danger" th:href="@{/credential-delete(credentialId=${credential.getCredentialId()})}" id="delete-credential-button">Delete</a>
                                        </td>
                                        <td th:text="${credential.getUrl()}">>Example Credential URL</th>
                                        <td th:text="${credential.getUsername()}">Example Credential Username</td>
                                        <td th:text="${credential.getPassword()}">Example Credential Password</td>
                                    </tr>
                                </tbody>
                            </table>
                        </div>

                        <div class="modal fade" id="credentialModal" tabindex="-1" role="dialog" aria-labelledby="credentialModalLabel" aria-hidden="true">
                            <div class="modal-dialog" role="document">
                                <div class="modal-content">
                                    <div class="modal-header">
                                        <h5 class="modal-title" id="credentialModalLabel">Credential</h5>
                                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                            <span aria-hidden="true">&times;</span>
                                        </button>
                                    </div>
                                    <div class="modal-body">
                                        <form th:object="${credential}" th:action="@{/credential-save}" action="#" method="POST">
                                            <input th:field="*{credentialId}" type="hidden" name="credentialId" id="credential-id">
                                            <input th:field="*{key}" type="hidden" name="credentialKey" id="credential-key">
                                            <div class="form-group">
                                                <label for="credential-url" class="col-form-label">URL</label>
                                                <input th:field="*{url}" type="text" name= "url" class="form-control" id="credential-url" maxlength="100" required>
                                            </div>
                                            <div class="form-group">
                                                <label for="credential-username" class="col-form-label">Username</label>
                                                <input th:field="*{username}" type="text" name= "username" class="form-control" id="credential-username" maxlength="30" required>
                                            </div>
                                            <div class="form-group">
                                                <label for="credential-password" class="col-form-label">Password</label>
                                                <input th:field="*{password}" type="text" name= "password" class="form-control" id="credential-password" maxlength="30" required>
                                            </div>
                                            <button id="credentialSubmit" type="submit" class="d-none"></button>
                                        </form>
                                    </div>
                                    <div class="modal-footer">
                                        <button type="button" class="btn btn-secondary" data-dismiss="modal" id="close-credential-button">Close</button>
                                        <button type="button" class="btn btn-primary" onclick="$('#credentialSubmit').click();" id="save-credential-button">Save changes</button>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>

        <script th:src="@{/js/jquery-slim.min.js}"></script>
        <script th:src="@{/js/popper.min.js}"></script>
        <script th:src="@{/js/bootstrap.min.js}"></script>

        <!--For opening the note modal-->
        <script type="text/javascript">
            // For opening the note modal
            function showNoteModal(note) {
                $('#note-id').val(note && note.noteId ? note.noteId : '');
                $('#note-title').val(note && note.noteTitle ? note.noteTitle : '');
                $('#note-description').val(note && note.noteDescription ? note.noteDescription : '');
                $('#noteModal').modal('show');
            }

            // For opening the credentials modal
            function showCredentialModal(credential, decryptedPassword) {
                $('#credential-id').val(credential && credential.credentialId ? credential.credentialId : '');
                $('#credential-key').val(credential && credential.key ? credential.key : '');
                $('#credential-url').val(credential && credential.url ? credential.url : '');
                $('#credential-username').val(credential && credential.username ? credential.username : '');
                $('#credential-password').val(credential && credential.password ? decryptedPassword : '');
                $('#credentialModal').modal('show');
            }
        </script>
    </body>
</html>